<?php
namespace Folha\Repositories;

use \Folha\Entities\VabIntegtranspm as Integtranspm ;

use \Setforms2\Shared\Connection;

class VabIntegtranspm extends \Doctrine\ORM\EntityRepository
{
    /**
     * Insere novo registro por execução de query.
     * Função criada para solucionar problema de inserção multipla em que é necessário usar
     * @param Integtranspm $registro
     * @return boolean
     * @throws \Exception
     */
    public static function inserirNovo(Integtranspm $registro)
    {
        try {
            $params = array(
                'P_CDOPERINCLUSAO' => $registro->getCdoperinclusao(),
                'P_CDOPERULTATU' => $registro->getCdoperultatu(),
                'P_DTFINVALIDADEINTEG' => $registro->getDtfinvalidadeinteg()->format('d/m/Y'),
                'P_DTINCLUSAO' => $registro->getDtinclusao()->format('d/m/Y'),
                'P_DTINIVALIDADEINTEG' => $registro->getDtinivalidadeinteg()->format('d/m/Y'),
                'P_DTULTATU' => $registro->getDtultatu()->format('d/m/Y'),
                'P_IDATIVO' => $registro->getIdativo(),
                'P_NRINTEGTRANSPM' => $registro->getNrintegtranspm(),
                'P_NRORG' => $registro->getNrorg(),
                'P_NRORGINCLUSAO' => $registro->getNrorginclusao(),
                'P_NRORGULTATU' => $registro->getNrorgultatu(),
            );

            $sql = <<<SQL
INSERT INTO VAB_INTEGTRANSPM(
    CDOPERINCLUSAO,
    CDOPERULTATU,
    DTFINVALIDADEINTEG,
    DTINCLUSAO,
    DTINIVALIDADEINTEG,
    DTULTATU,
    IDATIVO,
    NRINTEGTRANSPM,
    NRORG,
    NRORGINCLUSAO,
    NRORGULTATU
) VALUES (
    :P_CDOPERINCLUSAO,
    :P_CDOPERULTATU,
    :P_DTFINVALIDADEINTEG,
    :P_DTINCLUSAO,
    :P_DTINIVALIDADEINTEG,
    :P_DTULTATU,
    :P_IDATIVO,
    :P_NRINTEGTRANSPM,
    :P_NRORG,
    :P_NRORGINCLUSAO,
    :P_NRORGULTATU
)
SQL;

            $resultado = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->executeUpdate($sql, $params);

            if ($resultado) {
                return true;
            }
            return false;

        } catch (\Exception $e) {
            throw $e;
        }
    }
}