/* Tabela CTRLFORMNF: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CTRLFORMNF */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CTRLFORMNF utilizando a tabela Geral de Logs de Operaes */


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_CTRLFORMNF' AND
                 TYPE   = 'TR' 	              AND
	              U.UID  = O.UID                AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_CTRLFORMNF
GO

CREATE TRIGGER LOG_GER_CTRLFORMNF
ON CTRLFORMNF
   FOR INSERT, UPDATE, DELETE
AS

   DECLARE @V_USUARIO          VARCHAR(40);
   DECLARE @V_TIPO             VARCHAR(1);
   DECLARE @V_ITPESQ           VARCHAR(40);
   DECLARE @V_DESC             VARCHAR(300);
   DECLARE @V_DTOPER           DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO       VARCHAR(1);
   DECLARE @CDCTRLNUMENF_OLD   VARCHAR(10);
   DECLARE @NRCTRLFORMNF_OLD   VARCHAR(10);
   DECLARE @CDLOCALEMIS_OLD    VARCHAR(4);
   DECLARE @NRNUMEINIFRM_OLD   VARCHAR(20);
   DECLARE @NRNUMEFINFRM_OLD   VARCHAR(20);
   DECLARE @DTLIBESEQUNF_OLD   DATETIME;

   DECLARE @CDCTRLNUMENF_NEW   VARCHAR(10);
   DECLARE @NRCTRLFORMNF_NEW   VARCHAR(10);
   DECLARE @CDLOCALEMIS_NEW    VARCHAR(4);
   DECLARE @NRNUMEINIFRM_NEW   VARCHAR(20);
   DECLARE @NRNUMEFINFRM_NEW   VARCHAR(20);
   DECLARE @DTLIBESEQUNF_NEW   DATETIME;

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      CDCTRLNUMENF,
      NRCTRLFORMNF,
      CDLOCALEMIS,
      NRNUMEINIFRM,
      NRNUMEFINFRM,
      DTLIBESEQUNF,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
      DELETED
   WHERE
      (CDCTRLNUMENF+ NRCTRLFORMNF) NOT IN (SELECT CDCTRLNUMENF+ NRCTRLFORMNF FROM INSERTED)
   UNION ALL
   SELECT
      'U' IDCOMANDO,
      DELETED.CDCTRLNUMENF,
      DELETED.NRCTRLFORMNF,
      DELETED.CDLOCALEMIS,
      DELETED.NRNUMEINIFRM,
      DELETED.NRNUMEFINFRM,
      DELETED.DTLIBESEQUNF,
      INSERTED.CDCTRLNUMENF,
      INSERTED.NRCTRLFORMNF,
      INSERTED.CDLOCALEMIS,
      INSERTED.NRNUMEINIFRM,
      INSERTED.NRNUMEFINFRM,
      INSERTED.DTLIBESEQUNF
   FROM
      DELETED,
      INSERTED
   WHERE
      DELETED.CDCTRLNUMENF = INSERTED.CDCTRLNUMENF  AND
      DELETED.NRCTRLFORMNF = INSERTED.NRCTRLFORMNF
   UNION ALL
   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDCTRLNUMENF,
      NRCTRLFORMNF,
      CDLOCALEMIS,
      NRNUMEINIFRM,
      NRNUMEFINFRM,
      DTLIBESEQUNF
   FROM
      INSERTED
   WHERE
      (CDCTRLNUMENF+NRCTRLFORMNF) NOT IN (SELECT CDCTRLNUMENF+NRCTRLFORMNF FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @CDCTRLNUMENF_OLD,
                                 @NRCTRLFORMNF_OLD,
                                 @CDLOCALEMIS_OLD,
                                 @NRNUMEINIFRM_OLD,
                                 @NRNUMEFINFRM_OLD,
                                 @DTLIBESEQUNF_OLD,
                                 @CDCTRLNUMENF_NEW,
                                 @NRCTRLFORMNF_NEW,
                                 @CDLOCALEMIS_NEW,
                                 @NRNUMEINIFRM_NEW,
                                 @NRNUMEFINFRM_NEW,
                                 @DTLIBESEQUNF_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         SET @V_TIPO   = '3';
         SET @V_ITPESQ = @CDCTRLNUMENF_OLD+@NRCTRLFORMNF_OLD;

         IF @CDCTRLNUMENF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod=' + @CDCTRLNUMENF_OLD;
         END;

         IF @NRCTRLFORMNF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CtrlForm=' + @NRCTRLFORMNF_OLD;
         END;

         IF @CDLOCALEMIS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'LocalEmis=' + @CDLOCALEMIS_OLD;
         END;

         IF @NRNUMEINIFRM_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + '  NrInicial=' + @NRNUMEINIFRM_OLD;
         END;

         IF @NRNUMEFINFRM_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrFinal=' + @NRNUMEFINFRM_OLD;
         END;

         IF @DTLIBESEQUNF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DataLibera=' + CONVERT(VARCHAR, @DTLIBESEQUNF_OLD);
         END;
      END
      ELSE
         IF @V_ID_COMANDO = 'U' BEGIN
            IF (@CDCTRLNUMENF_OLD <> @CDCTRLNUMENF_NEW)  OR
               (@NRCTRLFORMNF_OLD <> @NRCTRLFORMNF_NEW)  OR
               (@CDLOCALEMIS_OLD  <> @CDLOCALEMIS_NEW )  OR
               (@NRNUMEINIFRM_OLD <> @NRNUMEINIFRM_NEW)  OR
               (@NRNUMEFINFRM_OLD <> @NRNUMEFINFRM_NEW)  OR
               (@DTLIBESEQUNF_OLD <> @DTLIBESEQUNF_NEW)  BEGIN

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @CDCTRLNUMENF_OLD+@NRCTRLFORMNF_OLD;


               IF @CDCTRLNUMENF_NEW <> @CDCTRLNUMENF_OLD BEGIN
                 SET @V_DESC = @V_DESC + 'Cod=' + @CDCTRLNUMENF_NEW;
               END;

               IF @NRCTRLFORMNF_NEW <> @NRCTRLFORMNF_OLD BEGIN
                 SET @V_DESC = @V_DESC + ' CtrlForm=' + @NRCTRLFORMNF_NEW;
               END;

               IF @CDLOCALEMIS_NEW <> @CDLOCALEMIS_OLD BEGIN
                 SET @V_DESC = @V_DESC + 'LocalEmis=' + @CDLOCALEMIS_NEW;
               END;

               IF @NRNUMEINIFRM_NEW <> @NRNUMEINIFRM_OLD BEGIN
                 SET @V_DESC = @V_DESC + '  NrInicial=' + @NRNUMEINIFRM_NEW;
               END;

               IF @NRNUMEFINFRM_NEW <> @NRNUMEFINFRM_OLD BEGIN
                 SET @V_DESC = @V_DESC + ' NrFinal=' + @NRNUMEFINFRM_NEW;
               END;

               IF @DTLIBESEQUNF_NEW <> @DTLIBESEQUNF_NEW BEGIN
                 SET @V_DESC = @V_DESC + ' DataLibera=' + CONVERT(VARCHAR, @DTLIBESEQUNF_NEW);
               END;
            END;
         END
         ELSE  BEGIN
            IF @CDCTRLNUMENF_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Cod=' + @CDCTRLNUMENF_NEW;
            END;

            IF @NRCTRLFORMNF_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CtrlForm=' + @NRCTRLFORMNF_NEW;
            END;

            IF @CDLOCALEMIS_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'LocalEmis=' + @CDLOCALEMIS_NEW;
            END;

            IF @NRNUMEINIFRM_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + '  NrInicial=' + @NRNUMEINIFRM_NEW;
            END;

            IF @NRNUMEFINFRM_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' NrFinal=' + @NRNUMEFINFRM_NEW;
            END;

            IF @DTLIBESEQUNF_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DataLibera=' + CONVERT(VARCHAR, @DTLIBESEQUNF_NEW);
            END;

            SET @V_TIPO = '1';
            SET @V_ITPESQ = @CDCTRLNUMENF_NEW+@NRCTRLFORMNF_NEW;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('CTRLFORMNF', @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @CDCTRLNUMENF_OLD,
                                    @NRCTRLFORMNF_OLD,
                                    @CDLOCALEMIS_OLD,
                                    @NRNUMEINIFRM_OLD,
                                    @NRNUMEFINFRM_OLD,
                                    @DTLIBESEQUNF_OLD,
                                    @CDCTRLNUMENF_NEW,
                                    @NRCTRLFORMNF_NEW,
                                    @CDLOCALEMIS_NEW,
                                    @NRNUMEINIFRM_NEW,
                                    @NRNUMEFINFRM_NEW,
                                    @DTLIBESEQUNF_NEW;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_CTRLFORMNF','4.11.105';
GO

